﻿--[[
        Give Me Mana:
                Copyright 2009 by MERK, Mileg
                based on code by Mileg and Stephen Blaising

	Updated 2014 by MERK
		Special thanks go out to GrimGrin
]]

GMMana_ADDONNAME = "Give Me Mana";
GMMana_MACRONAME = "GMMana";

GMMana_VERSION = "6.0.3d";

ALCHEM = "";
ALCHEM2 = "";
NoALCHEM = "INV_Misc_QuestionMark";
WIcon = "Inv_holiday_brewfestbuff_01";
--331
CONJWATER = "";
CharMP = 0;
DP = 0;
TP = 0;
QP = 0;
SP = 0;
GMMana_ZoneName = "Default";
GMMana_ZoneType = "Default";

local GMMana_UpdateFrame;
local GMManaUpdate       = {};
GMMana_UpdateFrame = CreateFrame("Frame")

function GMMana_OnLoad()

  SlashCmdList["GIVEMEMANACOMMAND"] = GMMana_SlashHandler;
  SLASH_GIVEMEMANACOMMAND1 = "/givememana";
  SLASH_GIVEMEMANACOMMAND2 = "/gmmana";
  SLASH_GIVEMEMANACOMMAND3 = "/gmm";
  
end

function GMMana_OnEvent(event)
  if (event == "PLAYER_LOGIN") then
    if (GetMacroIndexByName(GMMana_MACRONAME) == 0) then
      local numGenMacros, numCharMacros = GetNumMacros();
      if (numGenMacros < 36) then
        CreateMacro(GMMana_MACRONAME, WIcon, "", nil, nil)
      else
        GMMana_Print("You have 36 General Macros. Cannot add "..GMMana_MACRONAME.."!");
      end
    end
    if (GetSpellInfo(ALCH)) then
      ALCHEM = "[mod:ctrl,nocombat] "..ALCH..";";
      ALCHEM2 = "[] "..ALCH..";";
    else
      ALCHEM = "";
      NoALCHEM = WIcon;
    end
    if (GetSpellInfo(CONJR)) then
      CONJWATER = "[button:2] "..CONJR..";";
    elseif (GetSpellInfo(CONJW)) then
      CONJWATER = "[button:2] "..CONJW..";";
    else
      CONJWATER = "";
    end
    GMMana_UpdateFrame:SetScript("OnUpdate", GMMana_UpdateFrame_OnUpdate)
end
  if event == "BAG_UPDATE" then
		GMMana_UpdateFrame:SetScript("OnUpdate", GMMana_UpdateFrame_OnUpdate)
  end
end

function GMMana_UpdateFrame_OnUpdate(self, elapsed)
local affectingCombat = UnitAffectingCombat("player");
	for i = 0, 11 do
		if GMManaUpdate[i] then
			GMManaUpdate[i] = nil
		end
	end
	if GMManaUpdate.inv then
		GMManaUpdate.inv = nil
	end
		if(affectingCombat ~= 1) then
		  self:SetScript("OnUpdate", nil)
		  CharMP = UnitManaMax("player");
		  DP = CharMP * .02;
		  TP = CharMP * .03;
		  QP = CharMP * .04;
		  SP = CharMP * .05;
		  GMMana_MakeArray();
		  GMMana_Go();
		end
end

function GMMana_OnUpdate(event)
  if (GMMana_ZoneName ~= GetRealZoneText()) then
    GMMana_Go();
  end
end

function GMMana_SlashHandler(msg)
  if (msg) then
    msg = string.lower(msg);
  end
  if (msg == "help" or msg == "") then
    GMMana_Print(GMMana_ADDONNAME.." |cff3399CCv"..GMMana_VERSION.." ");
    GMMana_Print("Type /macro to open macro list.");
    GMMana_Print("Drag GMMana macro to your action bar.");
    GMMana_Print("This macro has two purposes.");
    GMMana_Print("During combat click to use best mana potion.");
    GMMana_Print("Otherwise click to drink best water.");
    GMMana_Print("Hold SHIFT and click to use/drink second best mana potion/water.");
    GMMana_Print("Hold ALT and click to use best mana potion out of combat.");
    GMMana_Print("Hold SHIFT+ALT and click to use second best mana potion out of combat.");
    GMMana_Print("Hold CTRL and click to open \"Alchemy\" tradeskill window.");
    GMMana_Print("Mages can right click to \"Conjure Water\".");
  end
end

function GMMana_GetZoneType()
  if (GMMana_ZoneName ~= GetRealZoneText()) then
    GMMana_ZoneName = GetRealZoneText();
    if ((GMMana_ZoneName == WSG) or (GMMana_ZoneName == AV) or (GMMana_ZoneName == AB) or (GMMana_ZoneName == EOTS) or (GMMana_ZoneName == SOTA)) then
      GMMana_ZoneType = "BG";
	elseif ((GMMana_ZoneName == TB) or (GMMana_ZoneName == TBP)) then
      GMMana_ZoneType = "TB";
    elseif ((GMMana_ZoneName == BOT) or (GMMana_ZoneName == EYE) or (GMMana_ZoneName == MECH) or (GMMana_ZoneName == ARCA)) then
      GMMana_ZoneType = "TK";
    elseif ((GMMana_ZoneName == SSC) or (GMMana_ZoneName == UB) or (GMMana_ZoneName == SV) or (GMMana_ZoneName == SP)) then
      GMMana_ZoneType = "CFR";
    elseif ((GMMana_ZoneName == BEM) or (GMMana_ZoneName == GL)) then
      GMMana_ZoneType = "BE";
    elseif ((GMMana_ZoneName == ARENA_BE) or (GMMana_ZoneName == ARENA_D) or (GMMana_ZoneName == ARENA_N) or (GMMana_ZoneName == ARENA_ROL) or (GMMana_ZoneName == ARENA_ROV)) then
      GMMana_ZoneType = "ARENA";
    else
      GMMana_ZoneType = "ALL";
    end
  end
end

function GMMana_Print(msg)
  if ((msg) and (strlen(msg) > 0)) then
    if (DEFAULT_CHAT_FRAME) then
      DEFAULT_CHAT_FRAME:AddMessage(msg, 1, 1, 0);
    end
  end
end

function GMMana_MakeArray()
  GMMana_Potions = {
[	46	]={	[1]=	"109222"	,[2]=	90	,[3]=	34000	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	DRAENIC MANA POTION
[	45	]={	[1]=	"109226"	,[2]=	90	,[3]=	17000	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	DRAENIC REJUVENATION POTION
[	44	]={	[1]=	"76098"	,[2]=	85	,[3]=	6000	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	MASTER MANA POTION
[	43	]={	[1]=	"57192"	,[2]=	80	,[3]=	4900	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	MYTHICAL MANA POTION
[	42	]={	[1]=	"42545"	,[2]=	70	,[3]=	4061	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	RUNIC MANA INJECTOR
[	41	]={	[1]=	"33448"	,[2]=	70	,[3]=	4061	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	RUNIC MANA POTION
[	40	]={	[1]=	"40077"	,[2]=	70	,[3]=	3967	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	CRAZY ALCHEMIST'S POTION
[	39	]={	[1]=	"43570"	,[2]=	50	,[3]=	3409	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	ENDLESS MANA POTION
[	38	]={	[1]=	"23823"	,[2]=	55	,[3]=	3409	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	MANA POTION INJECTOR
[	37	]={	[1]=	"33093"	,[2]=	55	,[3]=	3409	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	MANA POTION INJECTOR
[	36	]={	[1]=	"43530"	,[2]=	55	,[3]=	3409	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	ARGENT MANA POTION
[	35	]={	[1]=	"22832"	,[2]=	55	,[3]=	3409	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	SUPER MANA POTION
[	34	]={	[1]=	"33935"	,[2]=	55	,[3]=	3409	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	CRYSTAL MANA POTION
[	33	]={	[1]=	"32948"	,[2]=	55	,[3]=	3409	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	AUCHENAI MANA POTION
[	32	]={	[1]=	"32903"	,[2]=	55	,[3]=	3409	,[4]=	"CFR"	,[5]=	"ALL"	}, -- 	CENARION MANA SALVE
[	31	]={	[1]=	"32902"	,[2]=	55	,[3]=	3409	,[4]=	"TK"	,[5]=	"ALL"	}, -- 	BOTTLED NETHERGON ENERGY
[	30	]={	[1]=	"40067"	,[2]=	65	,[3]=	3409	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	ICY MANA POTION
[	29	]={	[1]=	"32783"	,[2]=	70	,[3]=	3409	,[4]=	"BE"	,[5]=	"ALL"	}, -- 	BLUE OGRE BREW
[	28	]={	[1]=	"32909"	,[2]=	70	,[3]=	3409	,[4]=	"BE"	,[5]=	"ALL"	}, -- 	BLUE OGRE BREW SPECIAL
[	27	]={	[1]=	"9144"	,[2]=	35	,[3]=	3234	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	WILDVINE POTION
[	26	]={	[1]=	"34440"	,[2]=	60	,[3]=	3125	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	MAD ALCHEMIST'S POTION
[	25	]={	[1]=	"22850"	,[2]=	65	,[3]=	3125	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	SUPER REJUVENATION POTION
[	24	]={	[1]=	"40087"	,[2]=	70	,[3]=	3117	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	POWERFUL REJUVENATION POTION
[	23	]={	[1]=	"76094"	,[2]=	85	,[3]=	3000	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	ALCHEMIST'S REJUVENATION
[	22	]={	[1]=	"113585"	,[2]=	90	,[3]=	3000	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	IRON HORDE REJUVENATION POTION
[	21	]={	[1]=	"13443"	,[2]=	41	,[3]=	2775	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	SUPERIOR MANA POTION
[	20	]={	[1]=	"18841"	,[2]=	41	,[3]=	2775	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	COMBAT MANA POTION
[	19	]={	[1]=	"13444"	,[2]=	49	,[3]=	2556	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	MAJOR MANA POTION
[	18	]={	[1]=	"28101"	,[2]=	55	,[3]=	2556	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	UNSTABLE MANA POTION
[	17	]={	[1]=	"31854"	,[2]=	61	,[3]=	2556	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	MAJOR COMBAT MANA POTION
[	16	]={	[1]=	"31855"	,[2]=	61	,[3]=	2556	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	MAJOR COMBAT MANA POTION
[	15	]={	[1]=	"31841"	,[2]=	61	,[3]=	2556	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	MAJOR COMBAT MANA POTION
[	14	]={	[1]=	"31840"	,[2]=	61	,[3]=	2556	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	MAJOR COMBAT MANA POTION
[	13	]={	[1]=	"17351"	,[2]=	45	,[3]=	2516	,[4]=	"BG"	,[5]=	"ALL"	}, -- 	MAJOR MANA DRAUGHT
[	12	]={	[1]=	"57193"	,[2]=	80	,[3]=	2450	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	MIGHTY REJUVENATION POTION
[	11	]={	[1]=	"63145"	,[2]=	0	,[3]=	2205	,[4]=	TB	,[5]=	"ALL"	}, -- 	BARADIN'S WARDENS MANA POTION
[	10	]={	[1]=	"64993"	,[2]=	0	,[3]=	2205	,[4]=	TB	,[5]=	"ALL"	}, -- 	HELLSCREAM'S REACH MANA POTION
[	9	]={	[1]=	"18253"	,[2]=	50	,[3]=	1813	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	MAJOR REJUVENATION POTION
[	8	]={	[1]=	"6149"	,[2]=	31	,[3]=	1715	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	GREATER MANA POTION
[	7	]={	[1]=	"17352"	,[2]=	35	,[3]=	1372	,[4]=	"BG"	,[5]=	"ALL"	}, -- 	SUPERIOR MANA DRAUGHT
[	6	]={	[1]=	"3827"	,[2]=	22	,[3]=	1160	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	MANA POTION
[	5	]={	[1]=	"35287"	,[2]=	55	,[3]=	1160	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	LUMINOUS BLUETAIL
[	4	]={	[1]=	"3385"	,[2]=	14	,[3]=	826	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	LESSER MANA POTION
[	3	]={	[1]=	"3087"	,[2]=	0	,[3]=	403	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	MUG OF SHIMMER STOUT
[	2	]={	[1]=	"2455"	,[2]=	5	,[3]=	288	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	MINOR MANA POTION
[	1	]={	[1]=	"2456"	,[2]=	5	,[3]=	216	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	MINOR REJUVENATION POTION
}

  GMMana_Water = {
[	124	]={	[1]=	"20516"	,[2]=	0	,[3]=	TP	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	BOBBING APPLE
[	123	]={	[1]=	"23172"	,[2]=	0	,[3]=	QP	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	REFRESHING RED APPLE
[	122	]={	[1]=	"75208"	,[2]=	0	,[3]=	DP	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	STORMWIND SURPRISE
[	121	]={	[1]=	"65500"	,[2]=	34	,[3]=	CharMP	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	CONJURED MANA COOKIE
[	120	]={	[1]=	"65515"	,[2]=	44	,[3]=	CharMP	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	CONJURED MANA BROWNIE
[	119	]={	[1]=	"65516"	,[2]=	54	,[3]=	CharMP	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	CONJURED MANA CUPCAKE
[	118	]={	[1]=	"65517"	,[2]=	64	,[3]=	CharMP	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	CONJURED MANA LOLLIPOP
[	117	]={	[1]=	"43518"	,[2]=	70	,[3]=	CharMP	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	CONJURED MANA PIE
[	116	]={	[1]=	"43523"	,[2]=	80	,[3]=	CharMP	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	CONJURED MANA STRUDEL
[	115	]={	[1]=	"65499"	,[2]=	85	,[3]=	CharMP	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	CONJURED MANA CAKE
[	114	]={	[1]=	"80610"	,[2]=	90	,[3]=	CharMP	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	CONJURED MANA PUDDING
[	113	]={	[1]=	"113509"	,[2]=	100	,[3]=	CharMP	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	CONJURED MANA FRITTER
[	112	]={	[1]=	"111544"	,[2]=	90	,[3]=	170000	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	FROSTBOAR JERKY
[	111	]={	[1]=	"117475"	,[2]=	90	,[3]=	170000	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	CLEFTHOOF MILK
[	110	]={	[1]=	"111455"	,[2]=	90	,[3]=	170000	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	SABERFISH BROTH
[	109	]={	[1]=	"117452"	,[2]=	90	,[3]=	170000	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	GORGROND MINERAL WATER
[	108	]={	[1]=	"116120"	,[2]=	94	,[3]=	102000	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	TASTY TALADOR LUNCH
[	107	]={	[1]=	"45932"	,[2]=	75	,[3]=	36276	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	BLACK JELLY
[	106	]={	[1]=	"105702"	,[2]=	85	,[3]=	30000	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	BOOMER BREW
[	105	]={	[1]=	"105705"	,[2]=	85	,[3]=	30000	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	CHANI'S BITTER BREW
[	104	]={	[1]=	"74636"	,[2]=	85	,[3]=	30000	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	GOLDEN CARP CONSOMME
[	103	]={	[1]=	"105701"	,[2]=	85	,[3]=	30000	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	GREENSTONE BREW
[	102	]={	[1]=	"105700"	,[2]=	85	,[3]=	30000	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	KUN-LAI KICKER
[	101	]={	[1]=	"105711"	,[2]=	85	,[3]=	30000	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	FUNKY MONKEY BREW
[	100	]={	[1]=	"105706"	,[2]=	85	,[3]=	30000	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	SHADO-PAN BREW
[	99	]={	[1]=	"105703"	,[2]=	85	,[3]=	30000	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	STORMSTOUT BREW
[	98	]={	[1]=	"104348"	,[2]=	85	,[3]=	30000	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	TIMELESS TEA
[	97	]={	[1]=	"105707"	,[2]=	85	,[3]=	30000	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	UNGA BREW
[	96	]={	[1]=	"105704"	,[2]=	85	,[3]=	30000	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	YAN-ZHU'S BLAZING BREW
[	95	]={	[1]=	"88532"	,[2]=	85	,[3]=	30000	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	LOTUS WATER
[	94	]={	[1]=	"81923"	,[2]=	90	,[3]=	30000	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	COBO COLA
[	93	]={	[1]=	"80618"	,[2]=	90	,[3]=	30000	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	CONJURED MANA BUNS
[	92	]={	[1]=	"108920"	,[2]=	90	,[3]=	30000	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	LEMON FLOUR PUDDING
[	91	]={	[1]=	"112449"	,[2]=	90	,[3]=	30000	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	IRON HORDE RATIONS
[	90	]={	[1]=	"62675"	,[2]=	80	,[3]=	23520	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	STARFIRE ESPRESSO
[	89	]={	[1]=	"62672"	,[2]=	80	,[3]=	23520	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	SOUTH ISLAND ICED TEA
[	88	]={	[1]=	"58257"	,[2]=	85	,[3]=	23520	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	HIGHLAND SPRING WATER
[	87	]={	[1]=	"63251"	,[2]=	85	,[3]=	23520	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	MEI'S MASTERFUL BREW
[	86	]={	[1]=	"68140"	,[2]=	85	,[3]=	23520	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	INVIGORATING PINEAPPLE PUNCH
[	85	]={	[1]=	"74822"	,[2]=	85	,[3]=	23520	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	SASPARILLA SINKER
[	84	]={	[1]=	"86026"	,[2]=	85	,[3]=	20000	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	PERFECTLY COOKED INSTANT NOODLES
[	83	]={	[1]=	"75026"	,[2]=	85	,[3]=	20000	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	GINSENG TEA
[	82	]={	[1]=	"85501"	,[2]=	85	,[3]=	20000	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	VISECLAW SOUP
[	81	]={	[1]=	"81924"	,[2]=	85	,[3]=	20000	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	CARBONATED WATER
[	80	]={	[1]=	"34760"	,[2]=	70	,[3]=	18138	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	GRILLED BONESCALE
[	79	]={	[1]=	"34761"	,[2]=	70	,[3]=	18138	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	SAUTEED GOBY
[	78	]={	[1]=	"34759"	,[2]=	70	,[3]=	18138	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	SMOKED ROCKFIN
[	77	]={	[1]=	"39520"	,[2]=	75	,[3]=	18138	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	KUNGALOOSH
[	76	]={	[1]=	"75037"	,[2]=	87	,[3]=	15000	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	JADE WITCH BREW
[	75	]={	[1]=	"75038"	,[2]=	90	,[3]=	15000	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	MAD BREWER'S BREAKFAST
[	74	]={	[1]=	"43086"	,[2]=	70	,[3]=	12126	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	FRESH APPLE JUICE
[	73	]={	[1]=	"44941"	,[2]=	70	,[3]=	12126	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	FRESH-SQUEEZED LIMEADE
[	72	]={	[1]=	"38698"	,[2]=	70	,[3]=	12126	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	BITTER PLASMA
[	71	]={	[1]=	"33444"	,[2]=	70	,[3]=	12126	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	PUNGENT SEAL WHEY
[	70	]={	[1]=	"59230"	,[2]=	80	,[3]=	11028	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	FUNGUS SQUEEZINGS
[	69	]={	[1]=	"59029"	,[2]=	80	,[3]=	11028	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	GREASY WHALE MILK
[	68	]={	[1]=	"68687"	,[2]=	80	,[3]=	11028	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	SCALDING MURGLESNOUT
[	67	]={	[1]=	"58256"	,[2]=	80	,[3]=	11028	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	SPARKLING OASIS WATER
[	66	]={	[1]=	"20031"	,[2]=	55	,[3]=	10710	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	ESSENCE MANGO
[	65	]={	[1]=	"32453"	,[2]=	65	,[3]=	10230	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	STAR'S TEARS
[	64	]={	[1]=	"33042"	,[2]=	65	,[3]=	10230	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	BLACK COFFEE
[	63	]={	[1]=	"29395"	,[2]=	65	,[3]=	10230	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	ETHERMEAD
[	62	]={	[1]=	"38431"	,[2]=	65	,[3]=	10230	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	BLACKROCK FORTIFIED WATER
[	61	]={	[1]=	"22018"	,[2]=	65	,[3]=	10230	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	CONJURED GLACIER WATER
[	60	]={	[1]=	"33053"	,[2]=	65	,[3]=	10230	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	HOT BUTTERED TROUT
[	59	]={	[1]=	"37253"	,[2]=	65	,[3]=	10230	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	FROSTBERRY JUICE
[	58	]={	[1]=	"40357"	,[2]=	65	,[3]=	10230	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	GRIZZLEBERRY JUICE
[	57	]={	[1]=	"34062"	,[2]=	65	,[3]=	10230	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	CONJURED MANA BISCUIT
[	56	]={	[1]=	"35954"	,[2]=	65	,[3]=	10230	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	SWEETENED GOAT'S MILK
[	55	]={	[1]=	"44750"	,[2]=	65	,[3]=	10230	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	MOUNTAIN WATER
[	54	]={	[1]=	"32668"	,[2]=	65	,[3]=	10230	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	DOS OGRIS
[	53	]={	[1]=	"27860"	,[2]=	65	,[3]=	10230	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	PURIFIED DRAENIC WATER
[	52	]={	[1]=	"34780"	,[2]=	65	,[3]=	10230	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	NAARU RATION
[	51	]={	[1]=	"29401"	,[2]=	65	,[3]=	10230	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	SPARKLING SOUTHSHORE CIDER
[	50	]={	[1]=	"30457"	,[2]=	65	,[3]=	10230	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	GILNEAS SPARKLING WATER
[	49	]={	[1]=	"13724"	,[2]=	45	,[3]=	9888	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	ENRICHED MANNA BISCUIT
[	48	]={	[1]=	"8079"	,[2]=	55	,[3]=	9720	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	CONJURED CRYSTAL WATER
[	47	]={	[1]=	"32455"	,[2]=	55	,[3]=	9720	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	STAR'S LAMENT
[	46	]={	[1]=	"18300"	,[2]=	55	,[3]=	9720	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	HYJAL NECTAR
[	45	]={	[1]=	"28112"	,[2]=	0	,[3]=	9018	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	UNDERSPORE POD
[	44	]={	[1]=	"19301"	,[2]=	51	,[3]=	9018	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	ALTERAC MANNA BISCUIT
[	43	]={	[1]=	"28399"	,[2]=	60	,[3]=	7248	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	FILTERED DRAENIC WATER
[	42	]={	[1]=	"38430"	,[2]=	60	,[3]=	7248	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	BLACKROCK MINERAL WATER
[	41	]={	[1]=	"29454"	,[2]=	60	,[3]=	7248	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	SILVERWINE
[	40	]={	[1]=	"30703"	,[2]=	60	,[3]=	7248	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	CONJURED MOUNTAIN SPRING WATER
[	39	]={	[1]=	"32722"	,[2]=	65	,[3]=	7248	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	ENRICHED TEROCONE JUICE
[	38	]={	[1]=	"8766"	,[2]=	45	,[3]=	5580	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	MORNING GLORY DEW
[	37	]={	[1]=	"8078"	,[2]=	45	,[3]=	5580	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	CONJURED SPARKLING WATER
[	36	]={	[1]=	"38429"	,[2]=	45	,[3]=	5580	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	BLACKROCK SPRING WATER
[	35	]={	[1]=	"43236"	,[2]=	75	,[3]=	4704	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	STAR'S SORROW
[	34	]={	[1]=	"33445"	,[2]=	75	,[3]=	4704	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	HONEYMINT TEA
[	33	]={	[1]=	"59229"	,[2]=	75	,[3]=	4704	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	MURKY WATER
[	32	]={	[1]=	"58274"	,[2]=	75	,[3]=	4704	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	FRESH WATER
[	31	]={	[1]=	"42777"	,[2]=	75	,[3]=	4704	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	CRUSADER'S WATERSKIN
[	30	]={	[1]=	"41731"	,[2]=	75	,[3]=	4704	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	YETI MILK
[	29	]={	[1]=	"63023"	,[2]=	35	,[3]=	3510	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	SWEET TEA
[	28	]={	[1]=	"19300"	,[2]=	35	,[3]=	3510	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	BOTTLED WINTERSPRING WATER
[	27	]={	[1]=	"8077"	,[2]=	35	,[3]=	3510	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	CONJURED MINERAL WATER
[	26	]={	[1]=	"1645"	,[2]=	35	,[3]=	3510	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	MOONBERRY JUICE
[	25	]={	[1]=	"61382"	,[2]=	9	,[3]=	2160	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	GARR'S LIMEADE
[	24	]={	[1]=	"4791"	,[2]=	25	,[3]=	2160	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	ENCHANTED WATER
[	23	]={	[1]=	"10841"	,[2]=	25	,[3]=	2160	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	GOLDTHORN TEA
[	22	]={	[1]=	"1708"	,[2]=	25	,[3]=	2160	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	SWEET NECTAR
[	21	]={	[1]=	"3772"	,[2]=	25	,[3]=	2160	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	CONJURED SPRING WATER
[	20	]={	[1]=	"90660"	,[2]=	15	,[3]=	1252	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	BLACK TEA
[	19	]={	[1]=	"9451"	,[2]=	15	,[3]=	1252	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	BUBBLING WATER
[	18	]={	[1]=	"19299"	,[2]=	15	,[3]=	1252	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	FIZZY FAIRE DRINK
[	17	]={	[1]=	"1205"	,[2]=	15	,[3]=	1252	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	MELON JUICE
[	16	]={	[1]=	"2136"	,[2]=	15	,[3]=	1252	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	CONJURED PURIFIED WATER
[	15	]={	[1]=	"49601"	,[2]=	0	,[3]=	907	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	VOLCANIC SPRING WATER
[	14	]={	[1]=	"17404"	,[2]=	0	,[3]=	907	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	BLENDED BEAN BREW
[	13	]={	[1]=	"49602"	,[2]=	5	,[3]=	907	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	EARL BLACK TEA
[	12	]={	[1]=	"49398"	,[2]=	5	,[3]=	907	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	FILTERED BILGE WATER
[	11	]={	[1]=	"2288"	,[2]=	5	,[3]=	907	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	CONJURED FRESH WATER
[	10	]={	[1]=	"49360"	,[2]=	5	,[3]=	907	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	GILNEAS SPRING WATER
[	9	]={	[1]=	"90659"	,[2]=	5	,[3]=	907	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	JASMINE TEA
[	8	]={	[1]=	"1179"	,[2]=	5	,[3]=	907	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	ICE COLD MILK
[	7	]={	[1]=	"63530"	,[2]=	5	,[3]=	907	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	REFRESHING PINEAPPLE PUNCH
[	6	]={	[1]=	"3448"	,[2]=	5	,[3]=	504	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	SENGGIN ROOT
[	5	]={	[1]=	"60269"	,[2]=	0	,[3]=	324	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	WELL WATER
[	4	]={	[1]=	"5350"	,[2]=	0	,[3]=	324	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	CONJURED WATER
[	3	]={	[1]=	"49254"	,[2]=	0	,[3]=	324	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	TARP COLLECTED DEW
[	2	]={	[1]=	"159"	,[2]=	0	,[3]=	324	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	REFRESHING SPRING WATER
[	1	]={	[1]=	"1401"	,[2]=	4	,[3]=	216	,[4]=	"ALL"	,[5]=	"ALL"	}, -- 	RIVERPAW TEA LEAF
}
end

function GMMana_Go()
  
  local manaPotionRank = 0;
  local BmanaPotionRank = 0;
  local manaPotionItemNum = 0;
  local BmanaPotionItemNum = 0;
  local oldPotionItemLink = "Nothing";
  local BoldPotionItemLink = "Nothing";
  local manaWaterRank = 0;
  local BmanaWaterRank = 0;
  local manaWaterItemNum = 0;
  local BmanaWaterItemNum = 0;
  local oldWaterItemLink = "Nothing";
  local BoldWaterItemLink = "Nothing";
  
  local Poverride = false
  local Woverride = false
  
  GMMana_GetZoneType();
  
  if (GMMana_ZoneName == nil) then
    GMMana_ZoneName = "Default";
  end
  
  for bagID = 0, 4, 1 do
    local bagSlotCnt = GetContainerNumSlots(bagID);
    if (bagSlotCnt > 0) then
      for slot = 1, bagSlotCnt, 1 do
        local itemLink = GetContainerItemLink(bagID, slot);
        local itemNumber = GMMana_NumFromLink(itemLink);
        if (itemNumber) then
          for index = 1, #(GMMana_Potions), 1 do
            if (GMMana_Potions[index][1] == itemNumber) then
              if (GMMana_Potions[index][2] <= UnitLevel("player")) then
                if ((GMMana_Potions[index][4] == GMMana_ZoneType) or (GMMana_Potions[index][4] == GMMana_ZoneName) or (GMMana_Potions[index][4] == "ALL")) then  
                  if (GMMana_Potions[index][4] ~= "ALL") then
                    Poverride = true
                    BoldPotionItemLink = oldPotionItemLink;
                    oldPotionItemLink = itemLink;
                    BmanaPotionRank = manaPotionRank;
                    manaPotionRank = GMMana_Potions[index][3];
                    BmanaPotionItemNum = manaPotionItemNum;
                    manaPotionItemNum = itemNumber;
                  end
                  if ((GMMana_Potions[index][3] > manaPotionRank) and (not Poverride)) then
                    BoldPotionItemLink = oldPotionItemLink;
                    oldPotionItemLink = itemLink;
                    BmanaPotionRank = manaPotionRank;
                    manaPotionRank = GMMana_Potions[index][3];
                    BmanaPotionItemNum = manaPotionItemNum;
                    manaPotionItemNum = itemNumber;
                  elseif ((GMMana_Potions[index][3] == manaPotionRank) and (itemLink ~= oldPotionItemLink) and (not Poverride)) then
                    local oldItemCnt = GetItemCount(oldPotionItemLink);
                    local newItemCnt = GetItemCount(itemLink);
                    if (newItemCnt <= oldItemCnt) then
                      oldPotionItemLink = itemLink;
                      manaPotionRank = GMMana_Potions[index][3];
                      manaPotionItemNum = itemNumber;
                    end
                  elseif ((GMMana_Potions[index][3] < manaPotionRank) and (GMMana_Potions[index][3] > BmanaPotionRank)) then
                    BoldPotionItemLink = itemLink;
                    BmanaPotionRank = GMMana_Potions[index][3];
                    BmanaPotionItemNum = itemNumber;
                  elseif ((GMMana_Potions[index][3] == BmanaPotionRank) and (itemLink ~= BoldPotionItemLink)) then
                    local oldItemCnt = GetItemCount(BoldPotionItemLink);
                    local newItemCnt = GetItemCount(itemLink);
                    if (newItemCnt <= oldItemCnt) then
                      BoldPotionItemLink = itemLink;
                      BmanaPotionRank = GMMana_Potions[index][3];
                      BmanaPotionItemNum = itemNumber;
                    end
                  end
                end
              end  
            end
          end
          for index = 1, #(GMMana_Water), 1 do
            if (GMMana_Water[index][1] == itemNumber) then
              if (GMMana_Water[index][2] <= UnitLevel("player")) then
                if ((GMMana_Water[index][4] == GMMana_ZoneType) or (GMMana_Water[index][4] == GMMana_ZoneName) or (GMMana_Water[index][4] == "ALL")) then  
                  if (GMMana_Water[index][4] ~= "ALL") then
                    Woverride = true
                    BoldWaterItemLink = oldWaterItemLink;
                    oldWaterItemLink = itemLink;
                    BmanaWaterRank = manaWaterRank;
                    manaWaterRank = GMMana_Water[index][3];
                    BmanaWaterItemNum = manaWaterItemNum;
                    manaWaterItemNum = itemNumber;
                  end
                  if ((GMMana_Water[index][3] > manaWaterRank) and (not Woverride)) then
                    BoldWaterItemLink = oldWaterItemLink;
                    oldWaterItemLink = itemLink;
                    BmanaWaterRank = manaWaterRank;
                    manaWaterRank = GMMana_Water[index][3];
                    BmanaWaterItemNum = manaWaterItemNum;
                    manaWaterItemNum = itemNumber;
                  elseif ((GMMana_Water[index][3] == manaWaterRank) and (itemLink ~= oldWaterItemLink) and (not Woverride)) then
                    local oldItemCnt = GetItemCount(oldWaterItemLink);
                    local newItemCnt = GetItemCount(itemLink);
                    if (newItemCnt <= oldItemCnt) then
                      oldWaterItemLink = itemLink;
                      manaWaterRank = GMMana_Water[index][3];
                      manaWaterItemNum = itemNumber;
                    end
                  elseif ((GMMana_Water[index][3] < manaWaterRank) and (GMMana_Water[index][3] > BmanaWaterRank)) then
                    BoldWaterItemLink = itemLink;
                    BmanaWaterRank = GMMana_Water[index][3];
                    BmanaWaterItemNum = itemNumber;
                  elseif ((GMMana_Water[index][3] == BmanaWaterRank) and (itemLink ~= BoldWaterItemLink)) then
                    local oldItemCnt = GetItemCount(BoldWaterItemLink);
                    local newItemCnt = GetItemCount(itemLink);
                    if (newItemCnt <= oldItemCnt) then
                      BoldWaterItemLink = itemLink;
                      BmanaWaterRank = GMMana_Water[index][3];
                      BmanaWaterItemNum = itemNumber;
                    end
                  end
                end
              end
            end
          end
        end
      end
    end
  end
  
  if ((manaPotionRank > 0) and (manaWaterRank > 0) and (BmanaPotionRank > 0) and (BmanaWaterRank > 0)) then
    EditMacro(GMMana_MACRONAME, GMMana_MACRONAME, "INV_Misc_QuestionMark", "#showtooltip\n/use "..CONJWATER..""..ALCHEM.." [mod:shift, combat] item:"..BmanaPotionItemNum.."; [combat] item:"..manaPotionItemNum.."; [mod:alt,mod:shift] item:"..BmanaPotionItemNum.."; [mod:alt] item:"..manaPotionItemNum.."; [mod:shift] item:"..BmanaWaterItemNum.."; [] item:"..manaWaterItemNum, nil, nil);
  elseif ((manaPotionRank > 0) and (manaWaterRank > 0) and (BmanaPotionRank > 0) and (BmanaWaterRank == 0)) then
    EditMacro(GMMana_MACRONAME, GMMana_MACRONAME, "INV_Misc_QuestionMark", "#showtooltip\n/use "..CONJWATER..""..ALCHEM.." [mod:shift, combat] item:"..BmanaPotionItemNum.."; [combat] item:"..manaPotionItemNum.."; [mod:alt,mod:shift] item:"..BmanaPotionItemNum.."; [mod:alt] item:"..manaPotionItemNum.."; [] item:"..manaWaterItemNum, nil, nil);
  elseif ((manaPotionRank > 0) and (manaWaterRank > 0) and (BmanaPotionRank == 0) and (BmanaWaterRank > 0)) then
    EditMacro(GMMana_MACRONAME, GMMana_MACRONAME, "INV_Misc_QuestionMark", "#showtooltip\n/use "..CONJWATER..""..ALCHEM.." [combat] item:"..manaPotionItemNum.."; [mod:alt] item:"..manaPotionItemNum.."; [mod:shift] item:"..BmanaWaterItemNum.."; [] item:"..manaWaterItemNum, nil, nil);
  elseif ((manaPotionRank > 0) and (manaWaterRank == 0) and (BmanaPotionRank > 0)) then
    EditMacro(GMMana_MACRONAME, GMMana_MACRONAME, "INV_Misc_QuestionMark", "#showtooltip "..ALCHEM.." [mod:shift] item:"..BmanaPotionItemNum.."; item:"..manaPotionItemNum.."\n/use "..CONJWATER..""..ALCHEM.." [mod:shift, combat] item:"..BmanaPotionItemNum.."; [combat] item:"..manaPotionItemNum.."; [mod:alt, mod:shift] item:"..BmanaPotionItemNum.."; [mod:alt] item:"..manaPotionItemNum, nil, nil);
  elseif ((manaPotionRank == 0) and (manaWaterRank > 0) and (BmanaWaterRank > 0)) then
    EditMacro(GMMana_MACRONAME, GMMana_MACRONAME, "INV_Misc_QuestionMark", "#showtooltip\n/use "..CONJWATER..""..ALCHEM.." [mod:shift] item:"..BmanaWaterItemNum.."; [] item:"..manaWaterItemNum, nil, nil);
  elseif ((manaPotionRank > 0) and (manaWaterRank > 0) and (BmanaPotionRank == 0) and (BmanaWaterRank == 0)) then
    EditMacro(GMMana_MACRONAME, GMMana_MACRONAME, "INV_Misc_QuestionMark", "#showtooltip\n/use "..CONJWATER..""..ALCHEM.." [combat] item:"..manaPotionItemNum.."; [mod:alt] item:"..manaPotionItemNum.."; [] item:"..manaWaterItemNum, nil, nil);
  elseif ((manaPotionRank > 0) and (manaWaterRank == 0) and (BmanaPotionRank == 0)) then
    EditMacro(GMMana_MACRONAME, GMMana_MACRONAME, "INV_Misc_QuestionMark", "#showtooltip "..ALCHEM.." item:"..manaPotionItemNum.."\n/use "..CONJWATER..""..ALCHEM.." [combat] item:"..manaPotionItemNum.."; [mod:alt] item:"..manaPotionItemNum, nil, nil);
  elseif ((manaPotionRank == 0) and (manaWaterRank > 0) and (BmanaWaterRank == 0)) then
    EditMacro(GMMana_MACRONAME, GMMana_MACRONAME, "INV_Misc_QuestionMark", "#showtooltip\n/use "..CONJWATER..""..ALCHEM.." item:"..manaWaterItemNum, nil, nil);
  elseif ((manaPotionRank == 0) and (manaWaterRank == 0)) then
    EditMacro(GMMana_MACRONAME, GMMana_MACRONAME, NoALCHEM, "#showtooltip\n/use "..CONJWATER..""..ALCHEM2, nil, nil);
  end
end

function GMMana_NumFromLink(itemLink)
  if (not itemLink) then
    return nil;
  end
  local _, _, itemNumber = strfind(itemLink, "item:(%d+):");
  return itemNumber;
end
